]> git.sesse.net Git - vlc/blob - contrib/bootstrap
ios: unbreak freetype contrib compilation with Xcode 5 and simplify the FLAG handling...
[vlc] / contrib / bootstrap
1 #! /bin/sh
2 # Copyright (C) 2003-2011 the VideoLAN team
3 #
4 # This program is free software; you can redistribute it and/or modify
5 # it under the terms of the GNU General Public License as published by
6 # the Free Software Foundation; either version 2 of the License, or
7 # (at your option) any later version.
8 #
9 # This program is distributed in the hope that it will be useful,
10 # but WITHOUT ANY WARRANTY; without even the implied warranty of
11 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
12 # GNU General Public License for more details.
13 #
14 # You should have received a copy of the GNU General Public License
15 # along with this program; if not, write to the Free Software
16 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston MA 02110-1301, USA.
17
18 #
19 # Command line handling
20 #
21 usage()
22 {
23         echo "Usage: $0 [--build=BUILD] [--host=HOST] [--prefix=PREFIX]"
24         echo "  --build=BUILD    configure for building on BUILD"
25         echo "  --host=HOST      cross-compile to build to run on HOST"
26         echo "  --prefix=PREFIX  install files in PREFIX"
27         echo "  --disable-FOO    configure to not build package FOO"
28         echo "  --enable-FOO     configure to build package FOO"
29         echo "  --disable-disc   configure to not build optical discs packages"
30         echo "  --disable-net    configure to not build networking packages"
31         echo "  --disable-sout   configure to not build stream output packages"
32         echo "  --enable-small   optimize libraries for size with slight speed decrease [DANGEROUS]"
33         echo "  --disable-gpl    configure to not build viral GPL code"
34 }
35
36 BUILD=
37 HOST=
38 PREFIX=
39 PKGS_ENABLE=
40 PKGS_DISABLE=
41 BUILD_ENCODERS="1"
42 BUILD_NETWORK="1"
43 BUILD_DISCS="1"
44 GPL="1"
45
46 if test ! -f "../../contrib/src/main.mak"
47 then
48         echo "$0 must be run from a subdirectory"
49         exit 1
50 fi
51
52 while test -n "$1"
53 do
54         case "$1" in
55                 --build=*)
56                         BUILD="${1#--build=}"
57                         ;;
58                 --help|-h)
59                         usage
60                         exit 0
61                         ;;
62                 --host=*)
63                         HOST="${1#--host=}"
64                         ;;
65                 --prefix=*)
66                         PREFIX="${1#--prefix=}"
67                         ;;
68                 --disable-disc)
69                         BUILD_DISCS=
70                         ;;
71                 --disable-net)
72                         BUILD_NETWORK=
73                         ;;
74                 --disable-sout)
75                         BUILD_ENCODERS=
76                         ;;
77                 --enable-small)
78                         ENABLE_SMALL=1
79                         ;;
80                 --disable-gpl)
81                         GPL=
82                         ;;
83                 --disable-*)
84                         PKGS_DISABLE="${PKGS_DISABLE} ${1#--disable-}"
85                         ;;
86                 --enable-*)
87                         PKGS_ENABLE="${PKGS_ENABLE} ${1#--enable-}"
88                         ;;
89                 *)
90                         echo "Unrecognized options $1"
91                         usage
92                         exit 1
93                         ;;
94         esac
95         shift
96 done
97
98 if test -z "$BUILD"
99 then
100         echo -n "Guessing build system... "
101         BUILD="`cc -dumpmachine`"
102         if test -z "$BUILD"; then
103                 echo "FAIL!"
104                 exit 1
105         fi
106         echo "$BUILD"
107 fi
108
109 if test -z "$HOST"
110 then
111         echo -n "Guessing host system...  "
112         HOST="$BUILD"
113         echo "$HOST"
114 fi
115
116 if test "$PREFIX"
117 then
118         # strip trailing slash
119         PREFIX="${PREFIX%/}"
120 fi
121
122 #
123 # Prepare files
124 #
125 echo "Creating configuration file... config.mak"
126 exec 3>config.mak || exit $?
127 cat >&3 << EOF
128 # This file was automatically generated.
129 # Any change will be overwritten if ../bootstrap is run again.
130 BUILD := $BUILD
131 HOST := $HOST
132 PKGS_DISABLE := $PKGS_DISABLE
133 PKGS_ENABLE := $PKGS_ENABLE
134 EOF
135
136 add_make()
137 {
138         while test -n "$1"
139         do
140                 echo "$1" >&3
141                 shift
142         done
143 }
144
145 add_make_enabled()
146 {
147         while test -n "$1"
148         do
149                 add_make "$1 := 1"
150                 shift
151         done
152 }
153
154 check_macosx_sdk()
155 {
156    [ -z "${OSX_VERSION}" ] && echo "OSX_VERSION not specified, assuming 10.7" && OSX_VERSION=10.7
157    if test -z "$SDKROOT"
158    then
159       SDKROOT=`xcode-select -print-path`/Platforms/MacOSX.platform/Developer/SDKs/MacOSX$OSX_VERSION.sdk
160       echo "SDKROOT not specified, assuming $SDKROOT"
161    fi
162
163    if [ ! -d "${SDKROOT}" ]
164    then
165       SDKROOT_NOT_FOUND=`xcode-select -print-path`/Platforms/MacOSX.platform/Developer/SDKs/MacOSX$OSX_VERSION.sdk
166       SDKROOT=`xcode-select -print-path`/SDKs/MacOSX$OSX_VERSION.sdk
167       echo "SDKROOT not found at $SDKROOT_NOT_FOUND, trying $SDKROOT"
168    fi
169
170    if [ ! -d "${SDKROOT}" ]
171    then
172       echo "*** ${SDKROOT} does not exist, please install required SDK, or set SDKROOT manually. ***"
173       exit 1
174    fi
175
176    add_make "MACOSX_SDK=${SDKROOT}"
177    add_make "OSX_VERSION ?= ${OSX_VERSION}"
178 }
179
180 check_android_sdk()
181 {
182         [ -z "${ANDROID_NDK}" ] && echo "You must set ANDROID_NDK environment variable" && exit 1
183         add_make "ANDROID_NDK := ${ANDROID_NDK}"
184         [ -z "${ANDROID_ABI}" ] && echo "You must set ANDROID_ABI environment variable" && exit 1
185         add_make "ANDROID_ABI := ${ANDROID_ABI}"
186         [ ${ANDROID_ABI} = "armeabi-v7a" ] && add_make_enabled "HAVE_NEON"
187         [ ${ANDROID_ABI} = "armeabi-v7a" ] && add_make_enabled "HAVE_ARMV7A"
188         [ ${ANDROID_ABI} = "armeabi" -a -z "${NO_ARMV6}" ] && add_make_enabled "HAVE_ARMV6"
189 }
190
191 test -z "$PREFIX" || add_make "PREFIX := $PREFIX"
192 test -z "$BUILD_DISCS" || add_make_enabled "BUILD_DISCS"
193 test -z "$BUILD_ENCODERS" || add_make_enabled "BUILD_ENCODERS"
194 test -z "$BUILD_NETWORK" || add_make_enabled "BUILD_NETWORK"
195 test -z "$ENABLE_SMALL" || add_make_enabled "ENABLE_SMALL"
196 test -z "$GPL" || add_make_enabled "GPL"
197
198 #
199 # Checks
200 #
201 OS="${HOST#*-}" # strip architecture
202 case "${OS}" in
203         apple-darwin*)
204                 if test -z "$BUILDFORIOS"
205                 then
206                         check_macosx_sdk
207                         add_make_enabled "HAVE_MACOSX" "HAVE_DARWIN_OS" "HAVE_BSD"
208                 else
209                         add_make_enabled "HAVE_IOS" "HAVE_DARWIN_OS" "HAVE_BSD" "HAVE_NEON" "HAVE_ARMV7A"
210                 fi
211                 ;;
212         *bsd*)
213                 add_make_enabled "HAVE_BSD"
214                 ;;
215         *android*)
216                 check_android_sdk
217                 add_make_enabled "HAVE_LINUX" "HAVE_ANDROID"
218                 case "${HOST}" in
219                         *arm*)
220                         add_make "PLATFORM_SHORT_ARCH := arm"
221                         ;;
222                         *i686*)
223                         add_make "PLATFORM_SHORT_ARCH := x86"
224                         ;;
225                         *mipsel*)
226                         add_make "PLATFORM_SHORT_ARCH := mips"
227                         ;;
228                 esac
229                 ;;
230         *linux*)
231                 add_make_enabled "HAVE_LINUX"
232                 ;;
233         *wince*)
234                 add_make_enabled "HAVE_WINCE"
235                 ;;
236         *mingw*)
237                 add_make_enabled "HAVE_WIN32"
238                 ;;
239 esac
240
241 #
242 # Results output
243 #
244 test -e Makefile && unlink Makefile
245 ln -sf ../../contrib/src/main.mak Makefile || exit $?
246 cat << EOF
247 Bootstrap completed.
248
249 Run "make" to start compilation.
250
251 Other targets:
252  * make install      same as "make"
253  * make prebuilt     fetch and install prebuilt binaries
254  * make list         list packages
255  * make fetch        fetch required source tarballs
256  * make fetch-all    fetch all source tarballs
257  * make distclean    clean everything and undo bootstrap
258  * make mostlyclean  clean everything except source tarballs
259  * make clean        clean everything
260  * make package      prepare prebuilt packages
261 EOF
262
263 mkdir -p ../../contrib/tarballs || exit $?